#!/usr/bin/env perl

use 5.012;
use strict;
use warnings;
use utf8;
use Encode;
use Benchmark qw(:all);

my $cnt = 10000;

my $iso2 =  "iso2.txt";
my $utf =   "utf8.txt";
my $ascii = "ascii.txt";

my $res = timethese($cnt, {
    'octets' => sub {
        open my $fhp, '<', $iso2 || die "Can't";
        my $octetsp = do { local $/; <$fhp>};
        close $fhp;
        my $strp = $octetsp;
    },
    'idecode' => sub {
        open my $fhi, '<', $iso2 || die "Can't";
        my $octetsi = do { local $/; <$fhi>};
        close $fhi;
        my $stri = decode("iso-8859-2", $octetsi);
    },
    'iopen' => sub {
        open my $fho, '<:encoding(iso-8859-2)', $iso2 || die "Can't";
        my $octetso = do { local $/; <$fho>};
        close $fho;
        my $stro = $octetso;
    },
    'uopen' => sub { 
        open my $fhu, '<:utf8', $utf || die "Can't";
        my $octetsu = do { local $/; <$fhu>};
        close $fhu;
        my $stru = $octetsu;
    },
    'uoascii' => sub { 
        open my $fha, '<:utf8', $ascii || die "Can't";
        my $octetsa = do { local $/; <$fha>};
        close $fha;
        my $stra = $octetsa;
    },
});
cmpthese $res;
